using System;
using System.Collections.Generic;
using System.Text;
using Teradyne.Igxl.PSetSignalsEditor.PSetSignalsEditorServices;

namespace Teradyne.Igxl.PSetSignalsEditor
{
    /// <summary>
    /// This class contains the implementation for the 
    /// handlers of the events generated by the PSet/Signal editor form.
    /// This class also initializes the various components of the editor and
    /// sets up the display.
    /// </summary>
    public class CoreEventHandler
    {
        /// <summary>
        /// Constructor - Initialize engines and the display here.
        /// </summary>
        public  CoreEventHandler()
        {
        }


        public List<string> GetPinGroupList() {
            DMGRLib.ITCOStrings str;
            List<string> pinList = new List<string>();

            str = MyServices.DmgrServiceCOM.ReferenceMgr.GetReferenceList(GlobalUtils.KEYSET_NAME, "");
            //str = GetMockPinList();


            pinList = CreateList((TERCOMMONOBJLib.ITCOStrings)str);
            return pinList;
        }

        

        

        /// <summary>
        /// This method converts an enumeration of strings into a list.
        /// </summary>
        /// <returns></returns>
        private static List<string> CreateList(TERCOMMONOBJLib.ITCOStrings str)
        {
            List<string> strList;
            strList = new List<string>();
            foreach (string s in str)
            {
                strList.Add(s);
            }
            return strList;
        }

        private DMGRLib.ITCOStrings GetMockPinList()
        {
            DMGRLib.ITCOStrings str = (DMGRLib.ITCOStrings)new TERCOMMONOBJLib.TCOStrings();
            str.Add("PinA");
            str.Add("PinB");
            str.Add("PinC");
            str.Add("PinD");
            str.Add("PinE");
            str.Add("PinF");
            str.Add("PinG");
            str.Add("PinH");
            str.Add("PinI");
            return str;
        }
    }
}
