/* -----------------------------------------------------------------
 * (c) Teradyne, Inc, 2009
 * All Rights Reserved
 * Inclusion of a copyright notice does not imply that this software
 * has been published.  This software is the trade secret information
 * of Teradyne, Inc.  Use of this software is only in accordance with
 * the terms of a license agreement from Teradyne, Inc.
 * -------------------------------------------------------------------
 */

/*-------------------------------------------------------------------------------
 *  The DataGridViewComboBoxCellEx provides customized method of DataGridViewComboBoxCell 
 *  information for a PSet/Signal definition and the respective methods on them. 
 * ------------------------------------------------------------------------------
 */

/*
 ***************************************************************************************
 *   Revision history:
 *   Author          Date        Description of change
 *   =================================================================
 *   Subeetha            23/10/09          Created.
 ***************************************************************************************
*/

namespace Teradyne.Igxl.PSetSignalsEditor
{
    using System;
    using System.Collections.Generic;
    using System.Text;
    using System.Windows.Forms;

    /// <summary>
    /// DataGridViewComboBoxCellEx defined to override Get property of EditType() method in DataGridViewComboBoxCell
    /// </summary>
    public class DataGridViewComboBoxCellEx : DataGridViewComboBoxCell 
    {
        /// <summary>
        /// Initializes a new instance of the DataGridViewComboBoxCellEx class.
        /// </summary>
        public DataGridViewComboBoxCellEx()
            : base()
        {
        }

        /// <summary>
        /// Gets the datatype as DataGridViewComboBoxEditingControlEx.
        /// </summary>
        public override Type EditType
        {
            get
            {
                return typeof(DataGridViewComboBoxEditingControlEx);
            }
        }
    }
}
