/* -----------------------------------------------------------------
 * (c) Teradyne, Inc, 2007
 * All Rights Reserved
 * Inclusion of a copyright notice does not imply that this software
 * has been published.  This software is the trade secret information
 * of Teradyne, Inc.  Use of this software is only in accordance with
 * the terms of a license agreement from Teradyne, Inc.
 * -------------------------------------------------------------------
 */
/*-------------------------------------------------------------------------------
 *  The NspcpItemsGridView class provides customized methods of DataGridView
 *  information for a PSet/Signal definition and the respective methods on them. 
 * ------------------------------------------------------------------------------
 */
/*
 ***************************************************************************************
 *   Revision history:
 *   Author          Date        Description of change
 *   =================================================================
 *   Abdul            12/05          Created.
 ****************************************************************************************/


using System;
using System.Collections.Generic;
using System.Text;
using System.Windows.Forms;

namespace Teradyne.Igxl.PSetSignalsEditor
{    
    public class NspcpItemsGridView : DataGridView
    {
        /// <summary>
        /// Handle the Tab or Shift-Tab to bypass Parameter Name column in the DataGridView.
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        protected override bool ProcessDataGridViewKey(KeyEventArgs e)
        {
            int colCount = base.ColumnCount;
            int rowCount = base.RowCount;
            if (base.CurrentCell == null || colCount == 1)
            {
                return base.ProcessDataGridViewKey(e);
            }
            if (e.Modifiers == Keys.Shift)
            {
                if (e.KeyCode == Keys.Tab)
                {
                    if (base.CurrentCell.ColumnIndex == 1)
                    {
                        if (base.CurrentCell.RowIndex >= 1)
                        {                           
                            int row = base.CurrentCell.RowIndex;
                            //Bypass current cell to previous Column & Row
                            base.CurrentCell = this[colCount - 1, row - 1];
                            return true;
                        }
                        else
                            return base.ProcessDataGridViewKey(e);

                    }

                }
            }
            else if (e.KeyCode == Keys.Tab)
            {
                if (base.CurrentCell.ColumnIndex == colCount - 1)
                {
                    if (base.CurrentCell.RowIndex < rowCount - 1)
                    {                        
                        int row = base.CurrentCell.RowIndex;
                        //Bypass current cell to Next Column & Row
                        base.CurrentCell = base[1, row + 1];
                        return true;
                    }
                    else
                        return base.ProcessDataGridViewKey(e);

                }
            }

            return base.ProcessDataGridViewKey(e);
        }
    }
}
