/* -------------------------------------------------------------------
 * (c) Teradyne, Inc, 2011
 * All Rights Reserved
 * Inclusion of a copyright notice does not imply that this software
 * has been published.  This software is the trade secret information
 * of Teradyne, Inc.  Use of this software is only in accordance with
 * the terms of a license agreement from Teradyne, Inc.
 * -------------------------------------------------------------------
 */
/*
 *********************************************************************
 *   Revision history:
 *   Author             Date            Description of change
 *   =================================================================
 *   Venkatachalam      09/07/11        Created
 *********************************************************************
 */
/*
 * *******************************************************************
 * This is the class that defines the PsetAndSignalEditorFlowDomainUtil 
 * objects
 * 
 * The Design:
 * PsetAndSignalEditorFlowDomainUtil is used to lock/unlock flow domains 
 * using ToolManager
 * *******************************************************************
 */

using System;
using System.Collections.Generic;
using System.Text;
using Teradyne.Igxl.PSetSignalsEditor.PSetSignalsEditorServices;

namespace Teradyne.Igxl.PSetSignalsEditor
{
    /// <summary>
    /// PCDToolImpl derives from ToolImplBase to hook up IToolListener reference from IGXL
    /// </summary>
    internal class PsetAndSignalEditorFlowDomainUtil : IDisposable
    {
        public PsetAndSignalEditorFlowDomainUtil(long toolID)
        {
            // Activate the flow domain which is selected in TDE/ToolManager toolbar before accessing 
            // flow domain dependent calls
            MyServices.ToolManager.ToolListener.LockToolFlowDomain(null, toolID);
        }

        #region IDisposable Members

        public void Dispose()
        {
            MyServices.ToolManager.ToolListener.UnlockToolFlowDomain();
        }

        #endregion
    }
}
